/**
* @file lightening_effect.h
*/

#ifndef _LIGHTENING_EFFECT
#define _LIGHTENING_EFFECT

#include "vector.h"
#include "vector2D.h"

#include "weather_effect.h"

#include "sound_buffer.h"
#include "sound_source.h"


class Billboard;

class LighteningEffect : public WeatherEffect
{
	public:
		LighteningEffect(const TiXmlElement* root = NULL);
		virtual ~LighteningEffect();

		virtual void loadParams(const TiXmlElement* root);

		virtual bool init();

		virtual bool activate();
		virtual bool deactivate();

		virtual void tick(float dt);

	private:
    Billboard* billboard;

    float flashFrequency;                   //!< frequency to activate itself
    float flashRisingTime;                  //!< time to rise
    float flashConstTime;                   //!< time to be drawn
    float flashFallTime;                    //!< time to fall

    float time;                             //!< time

    //bool  bRender;
    bool  bNewCoordinate;
    //Material*      material;
    //Vector         offset;
    float width;
    float height;

    float seedX;
    float seedZ;
    float seedTime;

    //OrxSound::SoundSource    soundSource;
    //OrxSound::SoundBuffer*   thunderBuffer;

};

#endif  /* _LIGHTENING_EFFECT */
